#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileio.h"

/*

This code is copyright 2004-2006 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

/* BMP */

void write_bmp(FILE *out, unsigned int *picture, int width, int height)
{
int image_width,padding;
int x,y,c;

  image_width=width*3;
  while ((image_width%4)!=0) image_width++;

  padding=(width*3)%4;
  if (padding==0) padding=4;

/* size: 14 bytes */

  write_chars(out,"BM");
  write_int(out,0);
  write_word(out,0);
  write_word(out,0);
  write_int(out,54);
/* head1: 14  head2: 40 */

  write_int(out,40);         /* biSize */
  write_int(out,width);
  write_int(out,height);
  write_word(out,1);
  write_word(out,24);
  write_int(out,0);          /* compression */
  write_int(out,image_width*height);
  write_int(out,0);          /* biXPelsperMetre */
  write_int(out,0);          /* biYPelsperMetre */
  write_int(out,0);
  write_int(out,0);

  for (y=height-1; y>=0; y--)
  {
    for (x=0; x<width; x++)
    {
      c=picture[x+(y*width)];
      putc((c&255),out);
      putc(((c>>8)&255),out);
      putc(((c>>16)&255),out);
    }

    for (x=padding; x<4; x++) putc(0,out);
  }
}

void debug_picture(unsigned int *picture, int width, int height)
{
int x,y,c,ptr;

  printf("%d x %d\n",width,height);

  ptr=0;
  for (y=0; y<height; y++)
  {
    for (x=0; x<width; x++)
    {
      c=picture[ptr++];
      c=((c&255)+((c>>8)&255)+((c>>16)&255))/3;

      if (c<20)
      { printf(" "); }
        else
      if (c<40)
      { printf("."); }
        else
      if (c<60)
      { printf(","); }
        else
      if (c<80)
      { printf(":"); }
        else
      if (c<100)
      { printf("!"); }
        else
      if (c<120)
      { printf("&"); }
        else
      if (c<180)
      { printf("@"); }
        else
      if (c<210)
      { printf("*"); }
        else
      { printf("#"); }
    }
    printf("|\n");
  }

}



