#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "bmp.h"
#include "jpeg.h"

/*

  Copyright 2006 by Michael Kohn - mike@mikekohn.net 
                                   http://www.mikekohn.net

  This software is *NOT* Opensource.  You may not use any of this code
  in your own programs.

*/

int print_double_matrix(double *matrix)
{
int i,j;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      printf("%03.3f ",matrix[i+(j*8)]);
    }
    printf("\n");
  }
  printf("\n");

  return 0;
}

int print_int_matrix(int *matrix)
{
int i,j;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      printf("%3d ",matrix[i+(j*8)]);
    }
    printf("\n");
  }
  printf("\n");

  return 0;
}

int transform_matrix(double *matrix_in, double *matrix_out)
{
int i,j;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      matrix_out[i+(j*8)]=matrix_in[j+(i*8)];
    }
  }

// print_double_matrix(matrix_in);
// print_double_matrix(matrix_out);

  return 0;
}

int build_idct_matrix_int()
{
int t;

  for (t=0; t<64; t++)
  {
    idct_matrix_int[t]=(int)(idct_matrix[t]);
  }

  return 0;
}

int build_idct_matrix()
{
double x,n,inc;
int i,j,ptr;

  // memset(idct_matrix,0,64*sizeof(double));

  i=0;
  x=1/sqrt(8);
  ptr=0;
  for (j=0; j<8; j++)
  {
    idct_matrix[ptr]=x;
    ptr=ptr+8;
  }

  inc=0;
 
  for (i=1; i<8; i++)
  {
    ptr=i;
    n=i;
    inc=inc+2;

    for (j=0; j<8; j++)
    {
      /* idct_matrix[ptr]=0.5*cos((n/(float)16)*M_PI); */
      idct_matrix[ptr]=0.5*cos((n*M_PI)/(double)16);
      ptr=ptr+8;
      n=n+inc;
    }
  }

/*
for (i=0; i<64; i++)
{
  if (i%8==0) printf("\n");
  printf("%f ",idct_matrix[i]);
}
printf("\n");
*/

  return 0;
}

int convert_y_to_rgb(int *picture, struct jpeg_info_t *jpeg_info)
{
int x,y,r;

  for (y=0; y<jpeg_info->height; y++)
  {
    for (x=0; x<jpeg_info->width; x++)
    {
      r=jpeg_info->y[x+(y*jpeg_info->width)];
      picture[x+(y*jpeg_info->width)]=(r<<16)+(r<<8)+r;
    }
  }

  return 0;
}

int idct2d(int *dct, int curr_dct, unsigned char *buffer, int width, int height)
{
double dct1d[64];
double d0;
int i,j,a;
int r;
int x0,y0;
int xdct,ydct;

  xdct=width/8;
  if ((width%8)!=0) xdct++;
  ydct=height/8;
  if ((height%8)!=0) ydct++;

  x0=curr_dct%xdct;
  y0=curr_dct/xdct;

  x0=x0*8;
  y0=y0*8;

// print_double_matrix(idct_matrix);

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      d0=0;
      for (a=0; a<8; a++)
      {
// printf("(%d*%d) + ",i+(a*8),a+(j*8));
// printf("(%3.3f*%3.3f) + ",idct_matrix[i+(a*8)],(double)dct[a+(j*8)]);

        d0=d0+(idct_matrix[a+(j*8)]*(double)dct[i+(a*8)]);
      }

      dct1d[j+(i*8)]=d0;  /* transform idct'd matrix */

    }
  }

  // print_double_matrix(dct1d);

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      // r=0;
      d0=0;
      for (a=0; a<8; a++)
      {
        // r=r+(idct_matrix[y+(j*8)]*dct1d[i+(y*8)]);
        // d0=d0+(idct_matrix[y+(j*8)]*dct1d[i+(y*8)]);
        d0=d0+(idct_matrix[a+(j*8)]*(double)dct1d[i+(a*8)]);
      }

// printf("d0=%f\n",d0);
      d0=d0+128;
      r=(int)d0;
      // r=r+128;
      if (r<0) r=0;
        else
      if (r>255) r=255;

      buffer[(x0+j)+((y0+i)*width)]=r;
// printf("r=%d\n",r);
    }
  }

  for (i=0; i<64; i++)
  {
    if (i%8==0) { j=x0+((y0+(i/8))*width); printf("\n"); }
    printf("%3d ",buffer[j]);
    j++;
  }
  printf("\n");

  return 0;
}
int idct2d_int(int *dct, int curr_dct, unsigned char *buffer, int width, int height)
{
int dct1d[64];
int d0;
int i,j,y;
int x0,y0;
int xdct,ydct;

  xdct=width/8;
  if ((width%8)!=0) xdct++;
  ydct=height/8;
  if ((height%8)!=0) ydct++;

  x0=curr_dct%xdct;
  y0=curr_dct/xdct;

  x0=x0*8;
  y0=y0*8;

  for (i=0; i<8; i++)
  {
    for (j=0; j<8; j++)
    {
      d0=0;
      for (y=0; y<8; y++)
      {
        d0=d0+(idct_matrix_int[y+(j*8)]*dct[i+(y*8)]);
      }

      dct1d[j+(i*8)]=d0;
/* printf("r=%d\n",r); */
    }
  }

  for (i=0; i<8; i++)
  {
    for (j=0; j<8; j++)
    {
      // r=0;
      d0=0;
      for (y=0; y<8; y++)
      {
        // r=r+(idct_matrix[y+(j*8)]*dct1d[i+(y*8)]);
        d0=d0+(idct_matrix_int[y+(j*8)]*dct1d[i+(y*8)]);
      }

      d0=d0+128;
      // r=(int)d0;
      // r=r+128;
      if (d0<0) d0=0;
        else
      if (d0>255) d0=255;

      buffer[(x0+i)+((y0+j)*width)]=d0;
/* printf("r=%d\n",r); */
    }
  }

  return 0;
}

int print_huffman_code(int code, int len, int limit_len)
{
int t;

  limit_len=len-limit_len;

  for (t=len-1; t>=limit_len; t--)
  {
    printf("%d",(code>>t)&1);
  }

  return 0;
}

int read_app0(int *segment)
{
  printf("    Identifier: %c%c%c%c\n",segment[0x02],
                                      segment[0x03],
                                      segment[0x04],
                                      segment[0x05]);
  printf("  VersionMajor: %d\n",segment[0x07]);
  printf("  VersionMinor: %d\n",segment[0x08]);
  printf("         Units: %d\n",segment[0x09]);
  printf("      Xdensity: %d\n",(segment[0x0a]<<8)+segment[0x0b]);
  printf("      Ydensity: %d\n",(segment[0x0c]<<8)+segment[0x0d]);
  printf("    Xthumbnail: %d\n",segment[0x0e]);
  printf("    Ythumbnail: %d\n",segment[0x0f]);

  return 0;
}

int read_comment(int *segment)
{
int t,length;

  length=(segment[0]<<8)+segment[1];

  printf("       Comment: ");

  for (t=2; t<length; t++)
  {
    if (segment[t]>=32 && segment[t]<=126) printf("%c",segment[t]);
  }

  printf("\n");

  return 0;
}

int read_baseline(int *segment, struct jpeg_info_t *jpeg_info)
{
int width,height;

  jpeg_info->precision=segment[0x02];
  height=(segment[0x03]<<8)+segment[0x04];
  width=(segment[0x05]<<8)+segment[0x06];
  jpeg_info->channel_tot=segment[0x07];
  jpeg_info->quant_table_num=segment[0x0a];

  if (jpeg_info->width<width) jpeg_info->width=width;
  if (jpeg_info->height<height) jpeg_info->height=height;

  printf("         Width: %d\n",width);
  printf("        Height: %d\n",height);
  printf(" NumOfChannels: %d ",jpeg_info->channel_tot);
  if (jpeg_info->channel_tot==1) printf("(grayscale)");
    else
  if (jpeg_info->channel_tot==3) printf("(YCbCr)");
    else
  if (jpeg_info->channel_tot==4) printf("(CMYK)");
    else
  printf("(Unknown)");

  printf("\n");
  printf("     ChannelID: %d ",segment[0x08]);
  if (segment[0x08]==1) printf("(Y)");
    else
  if (segment[0x08]==2) printf("(Cb)");
    else
  if (segment[0x08]==3) printf("(Cr)");
    else
  if (segment[0x08]==4) printf("(I)");
    else
  if (segment[0x08]==5) printf("(Q)");
  printf("\n");

  if (segment[0x08]==1)
  {
    jpeg_info->y_width=width;
    jpeg_info->y_height=height;
    jpeg_info->y=malloc(width*height);
  }
    else
  if (segment[0x08]==2)
  {
    jpeg_info->u_width=width;
    jpeg_info->u_height=height;
    jpeg_info->u=malloc(width*height);
  }
    else
  if (segment[0x08]==3)
  {
    jpeg_info->v_width=width;
    jpeg_info->v_height=height;
    jpeg_info->v=malloc(width*height);
  }

  printf("SamplngFactors: 0x%02x\n",segment[0x09]);
  printf(" QuantTableNum: 0x%02x\n",jpeg_info->quant_table_num);

  return 0;
}

int read_huffman(int *segment, struct jpeg_info_t *jpeg_info)
{
int table_id,table_class;
int codes_total;
int *counts;
int *codes;
int *lens;
int ptr,c,t,l;
int curr_code;
int length;

  ptr=2;
  length=(segment[0]<<8)+segment[1];

  while (ptr<length)
  {
    table_id=segment[ptr]&15;
    table_class=segment[ptr]>>4;
    ptr++;

    printf("   Table Class: 0x%02x ",table_class);
    if ((table_class)==0)
    { printf("(DC)\n"); }
      else
    { printf("(AC)\n"); }

    printf("      Table ID: 0x%02x\n",table_id);

    if (table_class==0)
    {
      if (jpeg_info->huffman_dc_codes[table_id]==0)
      {
        jpeg_info->huffman_dc_codes[table_id]=malloc((sizeof(int)*256));
        jpeg_info->huffman_dc_len[table_id]=malloc((sizeof(int)*256));
      }
      codes=jpeg_info->huffman_dc_codes[table_id];
      lens=jpeg_info->huffman_dc_len[table_id];
    }
      else
    {
      if (jpeg_info->huffman_ac_codes[table_id]==0)
      {
        jpeg_info->huffman_ac_codes[table_id]=malloc((sizeof(int)*256));
        jpeg_info->huffman_ac_len[table_id]=malloc((sizeof(int)*256));
      }
      codes=jpeg_info->huffman_ac_codes[table_id];
      lens=jpeg_info->huffman_ac_len[table_id];
    }

    codes_total=0;
    counts=&segment[ptr];

    printf("Code Len Count: ");
    for (t=0; t<16; t++) printf("%d ",segment[ptr+t]);
    printf("\n");

    ptr=ptr+16;

    for (t=0; t<16; t++) codes_total=codes_total+counts[t];

    memset(codes,0,256*sizeof(int));
    memset(lens,0,256*sizeof(int));

    c=0; l=1;
    curr_code=0;

    printf("         Codes: ");
    for (t=0; t<codes_total; t++) printf("%d ",segment[ptr+t]);
    printf("\n");
    
    while (codes_total>0)
    {
      if (counts[c]==0)
      {
        c++;
        l++;
        curr_code=curr_code<<1;
        /* curr_code++; */
      }
        else
      {
        lens[segment[ptr]]=l;
        codes[segment[ptr]]=curr_code;
        ptr++;
        counts[c]--;
        curr_code++;
        codes_total--;
      }
    }

/* printf("%d %d\n",ptr,length); */
  }


  if (ptr!=length) printf("Huffman table problem\n");

  return 0;
}

int read_quant(int *segment, struct jpeg_info_t *jpeg_info)
{
int length;
int ptr,t;
int table_num,quant_size;
int *quant_table;

  length=(segment[0]<<8)+segment[1];
  ptr=2;

  while (ptr<length)
  {
    table_num=segment[ptr]&15;
    quant_size=segment[ptr]>>4;
    ptr++;

    if (jpeg_info->quant_table[table_num]!=0)
    {
      printf("Error: Quantization table %d already used\n",table_num);
    }
      else
    {
      jpeg_info->quant_table[table_num]=malloc(sizeof(int)*64);
    }

    quant_table=jpeg_info->quant_table[table_num];

    for (t=0; t<64; t++)
    {
      if (quant_size==0)
      { quant_table[t]=segment[ptr++]; }
        else
      {
        quant_table[t]=(segment[ptr]<<8)+segment[ptr];
        ptr=ptr+2;
      }
    }

    for (t=0; t<64; t++)
    {
      if ((t%8)==0) printf("\n");
      printf("%3d ",quant_table[t]);
    }
    printf("\n\n");

    jpeg_info->quant_table_count++;
  }

  if (ptr!=length) printf("Error reading in Quantization tables %d/%d\n",ptr,length);
  printf("NumberOfTables: %d\n",jpeg_info->quant_table_count);

  return 0;
}

int read_image(FILE *in, int *segment, struct jpeg_info_t *jpeg_info)
{
/* struct jpeg_component_t jpeg_component[3]; */
int t,n,s,r,ch;
int *huffman_len;
int *huffman_codes;
int *quant_table;
unsigned int bitptr,holding;
int dct[64];
int dct_num;
int total_dct;
int curr_dct;
int last_dc_dct;

  printf("ComponentCount: %d\n",segment[0x02]);

  ch=3;
  for (t=0; t<segment[0x02]; t++)
  {
    printf("-----Component: %d\n",segment[ch++]);
    printf("    DC Huffman: %d\n",segment[ch]>>4);
    printf("    AC Huffman: %d\n",segment[ch]&15);
    ch++;
  }
  printf("SpectlSelStart: %d\n",segment[ch++]);
  printf("SpectralSelEnd: %d\n",segment[ch++]);
  printf("SuccessvApprox: 0x%02x\n",segment[ch++]);
  printf("\n");

  last_dc_dct=0;
  dct_num=0;
  bitptr=0;
  holding=0;
  total_dct=(jpeg_info->width>>3)*(jpeg_info->height>>3);
  curr_dct=0;
  quant_table=jpeg_info->quant_table[0];

/*
printf("%d\n",getc(in));
printf("%d\n",getc(in));
*/

  t=0;
  while(1)
  {
    if (dct_num==0)
    {
printf("DC curr_dct=%d\n",curr_dct);
      huffman_len=jpeg_info->huffman_dc_len[0];
      huffman_codes=jpeg_info->huffman_dc_codes[0];
    }
      else
    {
printf("AC\n");
      huffman_len=jpeg_info->huffman_ac_len[0];
      huffman_codes=jpeg_info->huffman_ac_codes[0];
    }

    for (n=0; n<256; n++)
    {
      if (huffman_len[n]==0) continue;
      while (bitptr<huffman_len[n])
      {
        ch=getc(in);
        if (ch==EOF) break;
        if (ch==0xff)
        {
printf("Got a 0xff in byte stream!\n");
          ch=getc(in);
          if (ch==0xd9)
          {
            fseek(in,ftell(in)-2,SEEK_SET);
            n=257;
            break;
          }
            else
          if (ch!=0x00) { printf("confused on 0xff%02x\n",ch); n=256; break; }
          ch=0xff;
        }
/*
        if (ch==0xff && t==0) { t++; printf("uh oh ch=0xff\n"); }
          else
        if (t==1 && ch==0xd9) { t++; break; }
*/
/*
          else
        if (t==1 && ch==0xff) { ch=0xff; }
          else
        { t=0; }
*/

        bitptr=bitptr+8;
        /* holding=(holding<<8)+reverse[ch]; */
        holding=(holding<<8)+ch;
      }

      printf("(%d) huff=%d len=%d <",n,huffman_codes[n],huffman_len[n]);
      print_huffman_code(huffman_codes[n],huffman_len[n],huffman_len[n]);
      printf("> | holding=%d bitptr=%d <",holding,bitptr);
      print_huffman_code(holding,bitptr,huffman_len[n]);
      printf(">\n");

// printf("bitptr=%d holding=%d code[%d]=%d len[%d]=%d\n",bitptr,holding,n,huffman_codes[n],n,huffman_len[n]);

      if ((holding>>(bitptr-huffman_len[n]))==huffman_codes[n])
      {
        bitptr=bitptr-huffman_len[n];
        holding=holding&((1<<bitptr)-1);
        break;
      }

/*
      if ((holding&((1<<huffman_len[n])-1))==huffman_codes[n])
      {
        bitptr=bitptr-huffman_len[n];
        holding=holding>>huffman_len[n];
        break;
      }
*/
    }

printf("code=%d 0x%02x\n",n,n);

    if (t==2) break;
    if (n>=256)
    {
      if (n!=258)
      {
        printf("Bad huffman code\n");
        printf("curr_dct=%d/%d\n",curr_dct,total_dct);
        printf("dct_num=%d\n",dct_num);
        printf("holding=%d bitptr=%d\n",holding,bitptr);
        break;
      }
        else
      { n=0; }
    }

    if (dct_num==0)   /* DC */
    {
printf("decoding DC\n");
      if (n!=0)
      {
        while (bitptr<n)
        {
          ch=getc(in);
          if (ch==0xff)
          {
            ch=getc(in);
            if (ch!=0x00)
            { printf("Expected 0xff\n"); break; }
              else
            { ch=0xff; }
          }

          holding=(holding<<8)+ch;
          bitptr=bitptr+8;
        }

        s=1<<(n-1);

        bitptr=bitptr-n;
        r=holding>>bitptr;
        holding=holding&((1<<bitptr)-1);

printf("DC additional bits=%d mag=%d\n",r,s);

        if (r<s)
        {
          r=-(r^((1<<n)-1));
        }

/*
        r=(1<<(n-1));
        bitptr--;
        s=holding>>bitptr;
        holding=holding&((1<<bitptr)-1);

        if (s==0)
        { s=-1; }
          else
        { s=1; }
*/

/* printf("DC sign bit=%d\n",s); */



/*
printf("DC=%d\n",r);
*/
      }
        else
      { r=0; }

      r=r*quant_table[0];

/*
      if (curr_dct==0)
      { dct[dct_num]=r; }
        else
*/
      { dct[dct_num]=last_dc_dct+r; }
/*
printf("DC DCT will be %d %d %d %d\n",dct[dct_num],r,dct_num,curr_dct);
*/
/* dct[dct_num]=1024; */

      last_dc_dct=dct[dct_num++];
    }
      else            /* AC */
    if (n==0x00)      /* rest of this DCT 8x8 is 0's */
    {
      for (r=dct_num; r<64; r++)
      {
        dct[zig_zag[dct_num++]]=0;
      }
    }
      else
    if (n==0xF0)     /* run of 16 AC's */
    {
      for (r=0; r<16; r++)
      {
        dct[zig_zag[dct_num++]]=0;
      }
    }
      else
    {
printf("decoding AC\n");
      s=n>>4;
      for (r=0; r<s; r++)
      {
        dct[zig_zag[dct_num++]]=0;
      }

      n=n&15;
      /* r=0; */

      if (n!=0)
      {
        while (bitptr<n)
        {
          ch=getc(in);
          if (ch==0xff)
          {
            ch=getc(in);
            if (ch!=0x00)
            { printf("Expected 0xff\n"); break; }
              else
            { ch=0xff; }
          }

          holding=(holding<<8)+ch;
          bitptr=bitptr+8;
        }

        s=1<<(n-1);

printf("bitptr=%d\n",bitptr);

        bitptr=bitptr-n;
        r=holding>>bitptr;
        holding=holding&((1<<bitptr)-1);

printf("AC additional bits=%d mag=%d\n",r,s);
printf("bitptr=%d\n",bitptr);

        if (r<s)
        {
          r=-(r^((1<<n)-1));
        }
      }

      /* r=r*quant_table[zig_zag[dct_num]]; */
      r=r*quant_table[dct_num];
      dct[zig_zag[dct_num++]]=r;

    }

printf("dct_num=%d\n",dct_num);

    if (dct_num>=64)
    {
if (dct_num>64) { printf("holy shit!\n"); }
for (n=0; n<64; n++)
{
  if ((n%8)==0) printf("\n");
  printf("%4d ",dct[n]);
}
printf("\n");
      dct_num=0;

// printf("height=%d\n",jpeg_info->y_height);

      idct2d(dct,curr_dct,jpeg_info->y,jpeg_info->y_width,jpeg_info->y_height);
      // idct2d_int(dct,curr_dct,jpeg_info->y,jpeg_info->y_width,jpeg_info->y_height);

      curr_dct++;
      if (curr_dct==total_dct) break;
    }
  }

  printf("total_dct=%d\n",total_dct);
  printf("ftell=%ld 0x%04x\n",ftell(in),(int)ftell(in));

  return 0;
}

int main(int argc, char *argv[])
{
FILE *in,*out;
struct jpeg_info_t jpeg_info;
int segment[65536];
int *picture=0;
int marker[2];
int length;
int t;

  printf("\nJPEG decompression - Copyright 2006 by Michael Kohn\n");
  printf("Version: May 8, 2006\n");
  printf("http://www.mikekohn.net/   mike@mikekohn.net\n\n");

  if (argc!=2)
  {
    printf("Usage: jpeg <filename>\n\n");
  }

  in=fopen(argv[1],"rb");
  if (in==0)
  {
    printf("Can't open file for input: %s\n",argv[1]);
    exit(1);
  }

  build_idct_matrix();
  build_idct_matrix_int();
  /* transform_matrix(dct_matrix,idct_matrix); */

  // print_double_matrix(idct_matrix);

  memset(&jpeg_info,0,sizeof(struct jpeg_info_t));

  marker[0]=getc(in);
  marker[1]=getc(in);

  if (marker[0]!=0xff || marker[1]!=0xd8)
  {
    printf("Not a jpeg\n");
  }
    else
  {
    while(1)
    {
      marker[0]=getc(in);
      if (marker[0]==EOF) { printf("ooops EOF\n"); break; }
      if (marker[0]!=0xff) { printf("oops not 0xff\n"); continue; }
      marker[1]=getc(in);

      if (marker[0]==EOF || marker[1]==EOF)
      {
        printf("oops! EOF\n");
        break;
      }

      printf("----------------------------------------\n");

      printf("     Signature: 0x%02x%02x   offset: 0x%06x",marker[0],marker[1],(int)ftell(in)-2);

      if (marker[1]==0xc0)
      { printf(" (Start Of Frame: Baseline)\n"); }
        else
      if (marker[1]==0xc1)
      { printf(" (Start Of Frame: Extended Sequential)\n"); }
        else
      if (marker[1]==0xc2)
      { printf(" (Start Of Frame: Progressive)\n"); }
        else
      if (marker[1]==0xc3)
      { printf(" (Start Of Frame: Lossless)\n"); }
        else
      if (marker[1]==0xdb)
      { printf(" (Quantization Table)\n"); }
        else
      if (marker[1]==0xdc)
      { printf(" (Number Lines)\n"); }
        else
      if (marker[1]==0xdd)
      { printf(" (Start Interval)\n"); }
        else
      if (marker[1]==0xc4)
      { printf(" (Huffman Table)\n"); }
        else
      if (marker[1]==0xda)
      { printf(" (Start Of Scan)\n"); }
        else
      if (marker[1]==0xe0)
      { printf(" (APP0)\n"); }
        else
      if (marker[1]==0xfe)
      { printf(" (Comment)\n"); }
        else
      if (marker[1]==0xd8)
      { printf(" (Start Of Image)\n"); }
        else
      if (marker[1]==0xd9)
      { printf(" (End Of Image)\n"); }
        else
      { printf("\n"); }

      if (marker[0]==0xff && marker[1]==0xd9)
      { break; }

      segment[0]=getc(in);
      segment[1]=getc(in);

      length=(segment[0]<<8)+segment[1];

      printf("        Length: %d\n",length);
      
      for (t=2; t<length; t++)
      {
        if ((segment[t]=getc(in))==EOF)
        {
          printf("WTF?  EOF?\n");
          break;
        }
      }

      if (marker[0]==0xff && marker[1]==0xe0)
      {
        read_app0(segment);
      }
        else
      if (marker[0]==0xff && marker[1]==0xfe)
      {
        read_comment(segment);
      }
        else
      if (marker[0]==0xff && marker[1]==0xc0)
      {
        read_baseline(segment,&jpeg_info);
      }
        else
      if (marker[0]==0xff && marker[1]==0xc4)
      {
        read_huffman(segment,&jpeg_info);
      }
        else
      if (marker[0]==0xff && marker[1]==0xdb)
      {
        read_quant(segment,&jpeg_info);
      }
        else
      if (marker[0]==0xff && marker[1]==0xda)
      {
        read_image(in,segment,&jpeg_info);
        jpeg_info.channel_num++;
        /* if (jpeg_info.channel_num>=jpeg_info.channel_tot) break; */
      }
    }
  }

  printf("----------------------------------------\n");

  for (t=0; t<4; t++)
  {
    if (jpeg_info.quant_table[t]!=0) free(jpeg_info.quant_table[t]);
    if (jpeg_info.huffman_dc_codes[t]!=0) free(jpeg_info.huffman_dc_codes[t]);
    if (jpeg_info.huffman_ac_codes[t]!=0) free(jpeg_info.huffman_ac_codes[t]);
    if (jpeg_info.huffman_dc_len[t]!=0) free(jpeg_info.huffman_dc_len[t]);
    if (jpeg_info.huffman_ac_len[t]!=0) free(jpeg_info.huffman_ac_len[t]);
  }

  fclose(in);

  picture=(int *)malloc(sizeof(int)*jpeg_info.width*jpeg_info.height);
  memset(picture,0,sizeof(int)*jpeg_info.width*jpeg_info.height);

  convert_y_to_rgb(picture,&jpeg_info);

  out=fopen("debug.bmp","wb");
  if (out!=0)
  {
    write_bmp(out,picture,jpeg_info.width,jpeg_info.height);
    fclose(out);
  }

  free(picture);
  if (jpeg_info.y!=0) free(jpeg_info.y);
  if (jpeg_info.u!=0) free(jpeg_info.u);
  if (jpeg_info.v!=0) free(jpeg_info.v);

  return 0;
}

