#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
FILE *in;
int segment[65536];
int marker[2];
int ch,t;
int length,file_size;

  if (argc!=2)
  {
    printf("Usage: jpeginfo <filename>\n\n");
  }

  in=fopen(argv[1],"rb");
  if (in==0)
  {
    printf("Can't open file for input: %s\n",argv[1]);
    exit(1);
  }

  for (t=0; t<2; t++)
  { marker[t]=getc(in); }

  if (marker[0]!=0xff || marker[1]!=0xd8)
  {
    printf("Not a jpeg\n");
  }
    else
  {
    file_size=2;

    while(1)
    {
      marker[0]=getc(in);
      marker[1]=getc(in);

      if (marker[0]==EOF || marker[1]==EOF)
      {
        printf("oops! EOF\n");
        break;
      }

      printf("     Signature: 0x%02x%02x\n",marker[0],marker[1]);

      if (marker[0]==0xff && marker[1]==0xd9)
      { break; }

      segment[0]=getc(in);
      segment[1]=getc(in);

      length=(segment[0]<<8)+segment[1];

      printf("        Length: %d\n",length);
      
      for (t=2; t<length; t++)
      {
        if ((segment[t]=getc(in))==EOF)
        {
          printf("WTF?  EOF?\n");
          break;
        }
      }


      if (marker[0]==0xff && marker[1]==0xc0)
      {
        printf("         Width: %d\n",(segment[0x03]<<8)+segment[0x04]);
        printf("        Height: %d\n",(segment[0x05]<<8)+segment[0x06]);
      }

      file_size=file_size+length+2;

      if (marker[0]==0xff && marker[1]==0xda)
      {
        t=0;
        while(1)
        {
          ch=getc(in);
          file_size++;
          if (ch==EOF) break;
          if (ch==0xff && t==0) t++;
            else
          if (t==1 && ch==0xd9) break;
            else
          { t=0; }
        }
      }
    }

    printf("Total jpeg size=%d\n",file_size);
  }

  fclose(in);

  return 0;
}

